#include <iostream>
using namespace std;

int main()
{
	// the nine cells; 0: empty, 1: player 1, 2: player 2
	// 1 for left-top, 2 for center-top, 3 for right-top, 4 for left-middle, ...
	int curCell = 0;
	
	while (cin >> curCell)
	{
		char cell1 = ' ', cell2 = ' ', cell3 = ' ', 
			 cell4 = ' ', cell5 = ' ', cell6 = ' ', 
			 cell7 = ' ', cell8 = ' ', cell9 = ' '; 
			
		int stepCount = 0; // number of completed steps
		int winner = 0; // 0: tie, 1: player 1 wins, 2: player 2 wins
		int winStep = 0;
		
		for(; stepCount < 9; stepCount++)
		{
			//curCell = 0; // the cell occupied in this step
			int curPlayer = stepCount % 2 + 1; // the current player; 1 or 2. 

			// set the cell occupation
			char curPlayerChar = '1';
			if(curPlayer == 2)
				curPlayerChar = '2';
				
			if(curCell == 1)
				cell1 = curPlayerChar; 
			else if(curCell == 2)
				cell2 = curPlayerChar; 
			else if(curCell == 3)
				cell3 = curPlayerChar; 
			else if(curCell == 4)
				cell4 = curPlayerChar; 
			else if(curCell == 5)
				cell5 = curPlayerChar; 
			else if(curCell == 6)
				cell6 = curPlayerChar; 
			else if(curCell == 7)
				cell7 = curPlayerChar; 
			else if(curCell == 8)
				cell8 = curPlayerChar; 
			else if(curCell == 9)
				cell9 = curPlayerChar; 

			// check whether anyone wins
			if((cell1 == cell2 && cell2 == cell3 && cell1 != ' ') ||
			   (cell4 == cell5 && cell5 == cell6 && cell4 != ' ') ||
			   (cell7 == cell8 && cell8 == cell9 && cell7 != ' ') ||
			   (cell1 == cell4 && cell4 == cell7 && cell1 != ' ') ||
			   (cell2 == cell5 && cell5 == cell8 && cell2 != ' ') ||
			   (cell3 == cell6 && cell6 == cell9 && cell3 != ' ') ||
			   (cell1 == cell5 && cell5 == cell9 && cell1 != ' ') ||
			   (cell3 == cell5 && cell5 == cell7 && cell3 != ' '))
			{
				winner = curPlayer;
				winStep = stepCount+1;
				break;
			}
			
			// to get the next number and then repeat
			if (stepCount != 8)
				cin >> curCell; 
		}

		// After the game ends, clean all the remaining numbers of that line
		while (stepCount < 8)
		{
			cin >> curCell; 
			stepCount++;
		}

		if (winner == 0) // no one wins and the game ends at the nineth step 
			winStep = 9;
			
		cout << winner << " " << winStep  << "\n";
	}
	
	return 0;
}
